unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, shellapi;

type
  TformMenuPrincipal = class(TForm)
    txtInfo: TMemo;
    GroupBox1: TGroupBox;
    opBytes: TRadioButton;
    opKB: TRadioButton;
    opMB: TRadioButton;
    opGB: TRadioButton;
    opTB: TRadioButton;
    txtCatalogarTamano: TEdit;
    lInfoTipoExt: TLabel;
    lInfoTamano: TStaticText;
    dlGuardar: TSaveDialog;
    bGuardar: TButton;
    bCerrar: TButton;
    LWEB: TLabel;
    opInfoConversion: TCheckBox;
    procedure txtCatalogarTamanoChange(Sender: TObject);
    procedure opBytesClick(Sender: TObject);
    procedure bGuardarClick(Sender: TObject);
    procedure bCerrarClick(Sender: TObject);
    procedure LWEBClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}

procedure TformMenuPrincipal.txtCatalogarTamanoChange(Sender: TObject);
var
  tamano, bytes, kilo, megas, gigas, teras : Double;
begin
  try
    tamano := StrToFloat (txtCatalogarTamano.Text);
    bytes := 0;
    if opBytes.Checked then
      bytes := tamano;
    if opKB.Checked then
      bytes := tamano * 1024;
    if opMB.Checked then
      bytes := tamano * 1048576;
    if opGB.Checked then
      bytes := tamano * 1073741824;
    if opTB.Checked then
      bytes := tamano * 1099511627776;
      
    kilo := bytes / 1024;
    megas := bytes /1048576;
    gigas := bytes /1073741824;
    teras := bytes /1099511627776;
    txtInfo.Clear;
    txtInfo.Lines.Add(FormatFloat('###,###,###,##0;-###,###,###,##0;0', bytes) +  ' Bytes son:');
    txtInfo.Lines.Add('');
    txtInfo.Lines.Add(FormatFloat('###,###,###,##0.000;-###,###,###,##0.000;0', kilo) + ' Kilobytes (KB)');
    txtInfo.Lines.Add(FormatFloat('###,###,###,##0.000000;-###,###,###,##0.000000;0', megas) + ' Megabytes (MB)');
    txtInfo.Lines.Add(FormatFloat('###,###,###,##0.000000000;-###,###,###,##0.000000000;0', gigas) + ' Gigabytes (GB)');
    txtInfo.Lines.Add(FormatFloat('###,###,###,##0.000000000000;-###,###,###,##0.000000000000;0', teras) + ' Terabytes (TB)');
    if opInfoConversion.Checked then
    begin
      txtInfo.Lines.Add('');
      txtInfo.Lines.Add('');
      txtInfo.Lines.Add('Donde:');
      txtInfo.Lines.Add('1 bit puede tener el valor cero  uno');
      txtInfo.Lines.Add('1 Byte = 8 Bit');
      txtInfo.Lines.Add('1 Kilobyte = 1024 Bytes (2 elevado a 10)');
      txtInfo.Lines.Add('1 Megabyte = 1048576 Bytes (2 elevado a 20)');
      txtInfo.Lines.Add('1 Gigabyte = 1073741824 Bytes (2 elevado a 30)');
      txtInfo.Lines.Add('1 Terabyte = 1099511627776 Bytes (2 elevado a 40)');
    end;

    if teras >= 1 then
      lInfoTamano.Caption := FormatFloat('###,###,###,##0.00;-###,###,###,##0.00;0', teras) + ' TB'
    else
      if gigas >= 1 then
        lInfoTamano.Caption := FormatFloat('###,###,###,##0.00;-###,###,###,##0.00;0', gigas) + ' GB'
      else
        if megas >= 1 then
          lInfoTamano.Caption := FormatFloat('###,###,###,##0.00;-###,###,###,##0.00;0', megas)  + ' MB'
        else
          if kilo >= 1 then
            lInfoTamano.Caption := FormatFloat('###,###,###,##0.00;-###,###,###,##0.00;0', kilo) + ' KB'
          else
            lInfoTamano.Caption := FormatFloat('###,###,###,##0;-###,###,###,##0;0', bytes) + ' Bytes';
  except
    lInfoTamano.Caption := 'Introduzca un nmero vlido';
    txtInfo.Clear;
  end;
end;

procedure TformMenuPrincipal.opBytesClick(Sender: TObject);
begin
  if opBytes.Checked then
    lInfoTipoExt.Caption := 'Introduzca los Bytes para calcular';
  if opKB.Checked then
    lInfoTipoExt.Caption := 'Introduzca los Kilobytes para calcular';
  if opMB.Checked then
    lInfoTipoExt.Caption := 'Introduzca los Megabytes para calcular';
  if opGB.Checked then
    lInfoTipoExt.Caption := 'Introduzca los Gigabytes para calcular';
  if opTB.Checked then
    lInfoTipoExt.Caption := 'Introduzca los Terabytes para calcular';
  txtCatalogarTamanoChange (Self);
end;

procedure TformMenuPrincipal.bGuardarClick(Sender: TObject);
begin
  if txtInfo.Lines.Count <= 0 then
    MessageDlg('No hay datos para guardar.', mtWarning, [mbok], 0)
  else
  begin
    dlGuardar.FileName := 'Resultado conversin';
    dlGuardar.Filter := 'Fichero de texto (*.txt)|*.txt|Todos los ficheros (*.*)|*.*';
    dlGuardar.Title := 'Guardar resultado en fichero...';
    if dlGuardar.Execute then
      txtInfo.Lines.SaveToFile(dlGuardar.FileName);
  end;
end;

procedure TformMenuPrincipal.bCerrarClick(Sender: TObject);
begin
  close;
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar(LWEB.CAPTION),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.
